/*  elements.cpp -
    This file is part of KBillar
    Copyright (C) 2000,2001  Antonio Larrosa Jimenez
    KBillar's homepage : http://devel-home.kde.org/~larrosa/kbillar.html
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 
    Send comments and bug fixes to Antonio Larrosa <larrosa@kde.org>
 
 ***************************************************************************/
#include "kglelements.h"
//#include <kapp.h>
//#include <kconfig.h>
//#include <kglsphere.h>
//#include <kglarrow.h>
//#include <kglmesh.h>
//#include <kglband.h>
//#include <kgluniverse.h>
#include <kdebug.h>
//#include <kstddirs.h>
//#include <qpixmap.h>
//#include <qpainter.h>
#include <stdlib.h>
#include <stdio.h>

Vector &Vector::setNorm(float n)
{
  float r=norm();
  if (r==0) return *this;
  (*this)*=(n/r);
  return *this;
}

void Vector::toSquare()
{
  (*this)*=norm();
}

Vector Vector::decomp(const Vector &v) const
{
  Vector tmp(v);
  tmp.toUnit();

  tmp*=x()*tmp.x()+y()*tmp.y()+z()*tmp.z();
  
  return tmp;
}

Vector Vector::projectToPlane(const Vector &n) const
{
  return (*this)-decomp(n);
}

void Vector::print(const char *s)
{
  kdDebug() << s << ":" << m_x << " " << m_y << " " << m_z << "\n";
}

QTextStream &operator<<( QTextStream &s, const Vector &v )
{
  return s << v.x() << " " << v.y() << " " << v.z() ;
}

QTextStream &operator>>( QTextStream &s, Vector &v )
{
  float x;
  s >> x;
  v.setX(x);
  s >> x;
  v.setY(x);
  s >> x;
  v.setZ(x);
  return s;
}

